<template>
  <svn-pro-card
    variant="text"
    :link="false"
    class="min-w-[320px] max-w-[672px] max-h-[400px]"
    @click="goToItemShow"
  >
    <div
      class="w-full h-full flex"
      :class="cardSize === 'compact' ? 'flex-col' : 'flex-row'"
    >
      <div
        class="w-full flex flex-col justify-center items-center bg-cover bg-center"
        :class="cardSize === 'compact' ? 'h-[180px] rounded-tl-[12px] rounded-tr-[12px]' : 'max-w-[180px] h-[224px] rounded-tl-[12px] rounded-bl-[12px]'"
        :style="{'background-image': `url('${image}')`}"
      />

      <div
        class="flex-1 p-4 flex flex-col gap-4 self-stretch border border-opacity-100"
        :class="cardSize === 'compact' ? 'justify-normal items-center !border-t-transparent rounded-bl-[12px] rounded-br-[12px]' : 'justify-between items-start !border-l-transparent rounded-tr-[12px] rounded-br-[12px]'"
      >
        <div
          class="w-full flex flex-col gap-4"
          :class="cardSize === 'compact' ? '' : status !== 'acquired' ? 'h-[124px] items-start' : 'h-[124px] items-start flex-1 justify-between'"
        >
          <!-- Training title -->
          <div class="flex flex-1 items-start !h-[64px]">
            <svn-pro-title h6 medium class="line-clamp-2">
              {{ title }}
            </svn-pro-title>
          </div>

          <div class="w-full flex flex-col gap-4">
            <div class="w-full flex items-center gap-4">
              <!-- Info tag -->
              <svn-pro-info-tag
                :tag-type="getInfoTagType()"
                tag-style="filled"
                :tag-size="cardSize"
                :text="getInfotagText()"
              />

              <!-- Duration -->
              <div class="flex items-center gap-1">
                <div>
                  <Icon
                    icon="mingcute:time-line"
                    height="16"
                    width="16"
                    class="text-onSurfaceVariant"
                  />
                </div>

                <svn-pro-text body-medium regular color="onSurfaceVariant">
                  {{ duration }}
                </svn-pro-text>
              </div>
            </div>

            <!-- Progress bar -->
            <svn-pro-progress-linear
              v-if="status === 'in_progress'"
              :model-value="progress"
            />
          </div>
        </div>

        <!-- Primary button -->
        <svn-pro-button
          v-if="status !== 'acquired'"
          :text="primaryButtonText"
          class="w-full"
          :variant="getPrimaryButtonVariant()"
          :prepend-icon="getPlayIcon()"
          @click="clickPrimaryButton"
        />
      </div>
    </div>
  </svn-pro-card>
</template>

<script setup>
import SvnProText from '../styles/SvnProText.vue';
import SvnProTitle from '../styles/SvnProTitle.vue';
import SvnProInfoTag from '../chip/SvnProInfoTag.vue';
import SvnProButton from '../button/SvnProButton.vue';
import SvnProProgressLinear from '../progress/SvnProProgressLinear.vue';
import { Icon } from '@iconify/vue';

const props = defineProps({
  cardSize: {
    type: String,
    default: "compact",
  },
  image: {
    type: String,
    default: undefined,
  },
  title: {
    type: String,
    default: undefined,
  },
  duration: {
    type: String,
    default: undefined,
  },
  progress: {
    type: Number,
    default: undefined,
  },
  status: {
    type: String,
    default: "not_started",
  },
  primaryButtonText: {
    type: String,
    default: "Start training!",
  }
});

const emits = defineEmits(['click-primary-button', 'go-to-item-show'])

const getPrimaryButtonVariant = () => {
  switch (props?.status) {
    case "not_started":
      return "flat"
    case "in_progress":
      return "outlined"
    default:
      return "primary"
  }
}

const getInfoTagType = () => {
  switch (props?.status) {
    case "not_started":
      return "error"
    case "in_progress":
      return "warning"
    case "acquired":
      return "success"
    default:
      return "error"
  }
}

const getInfotagText = () => {
  switch (props?.status) {
    case "not_started":
      return "Not started"
    case "in_progress":
      return "In progress"
    case "acquired":
      return "Completed"
    default:
      return "Not started"
  }
}

const getPlayIcon = () => {
  switch (props?.status) {
    case "not_started":
      return "custom:mingcute:play-fill"
    case "in_progress":
      return "custom:mingcute:play-line"
    default:
      return "custom:mingcute:play-fill"
  }
}

const clickPrimaryButton = () => {
  emits('click-primary-button')
}

const goToItemShow = () => {
  emits('go-to-item-show')
}

const getDurationText = () => {
  if (Number(props?.duration) >= 60) {
    let hours = Number(props?.duration)/60
    let minutes = Number(props?.duration)%60

    if (hours) {
      return `${hours}h${minutes}`
    } else {
      return `${minutes}min`
    }
  }
}
</script>